%MACRO calc_genmod_iter_stats_dp;

  /* Wrapper for calculating various genmod stats per iteration at a DP site. */

   %PUT;
   %PUT -----   Start of the calc_genmod_iter_stats_dp  iter_nb=&iter_nb. ;
   %PUT;

%IF       (&regr_type_cd. NE 1)
           OR  (&regr_type_cd. = 1 AND &last_iter_in.=1)
	%THEN
	                  %DO;
		 %calc_genmod_vars(tbl_name_in=&reg_ds_dp_in.
									  ,Model_Coeff=&infolder_lib..&prefix_prev.Model_Coeff
									  ,independent_vars=&independent_vars.
									  ,dependent_vars=&dependent_vars.
		                              ,regr_type_cd=&regr_type_cd.
									  ,dp_cd=&dp_cd.
									  ,freq=&freq.
		                              ,weight=&weight.
									  ,tbl_name_out=&prefix_dp.reg_vars); 


		PROC DATASETS  MEMTYPE=DATA NOLIST;
		   MODIFY &prefix_dp.reg_vars;
		     ATTRIB _ALL_ LABEL=" ";
		     ATTRIB _ALL_ FORMAT=;
		RUN;
		QUIT;

	/*   The  dataset &msoc_lib..&prefix.resid_sum has overall sum of residuals, response, deviance, 
	    log-likelihood, etc. for a given DP. 	
	*/

PROC MEANS DATA=&prefix_dp.reg_vars NWAY NOPRINT;
	 CLASS dp_cd;
		  FREQ _FREQ_;		
			 VAR _RESP_  _MEAN_ _RESP_W_ _MEAN_W_ _LL_  _L_  _DEV_ _RESIDUAL_   
					    _PRESIDUAL_ _PRESIDUAL_SQ_  _DRESIDUAL_ _DRESIDUAL_SQ_	 
                       _WEIGHT_
						;
	       OUTPUT 	 OUT=&msoc_lib..&prefix.resid_sum( DROP=_TYPE_ )
						     MIN(_MEAN_)=Min__MEAN_ MAX(_MEAN_)=Max__MEAN_ 	
                            SUM(_WEIGHT_)=_SUMWGT_
                            SUM=/AUTONAME;
	    RUN;	  
					  %END;

 		/*20160705. Calculate SSCP for all itearation except &last_iter_in=1 AND &regr_type_cd=1 .*/

   %IF %LENGTH(&_sscp_output_ds_sh.) >0 %THEN;
									 %DO;
		   %calculate_sscp(tbl_name_in=&_sscp_input_ds.
                         ,independent_vars=&independent_vars.
						 ,dependent_vars=&dependent_vars.
						 ,freq=%STR(&freq.) 
                         ,weight=&weight_sscp.
						 ,tbl_name_out=&_sscp_output_ds.);
								   %END;

  %PUT;
   %PUT -----   End of the calc_genmod_iter_stats_dp  iter_nb=&iter_nb. ;
   %PUT;

%MEND; /* End of calc_genmod_iter_stats_dp*/